/* task.c generated by valac 0.56.17, the Vala compiler
 * generated from task.vala, do not modify */

/* task.vala
 *
 * Copyright (C) 2013  Maciej Piechotka
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Maciej Piechotka <uzytkownik2@gmail.com>
 */

#include "gee.h"
#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef struct _GeeTaskData GeeTaskData;
#define _gee_promise_unref0(var) ((var == NULL) ? NULL : (var = (gee_promise_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gee_task_data_free0(var) ((var == NULL) ? NULL : (var = (gee_task_data_free (var), NULL)))
typedef struct _GeeAsyncTaskData GeeAsyncTaskData;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_thread_pool_free0(var) ((var == NULL) ? NULL : (var = (g_thread_pool_free (var, FALSE, TRUE), NULL)))

struct _GeeTaskData {
	GeeTask function;
	gpointer function_target;
	GeePromise* promise;
};

struct _GeeAsyncTaskData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GeeFuture* _tmp0_;
	GeeFuture* _tmp1_;
	GError* _inner_error0_;
};

static GOnce gee_task_data_async_pool;
static GOnce gee_task_data_async_pool = G_ONCE_INIT;

 G_GNUC_INTERNAL void gee_task_data_free (GeeTaskData * self);
 G_GNUC_INTERNAL GeeTaskData* gee_task_data_new (void);
 G_GNUC_INTERNAL GThreadPool* gee_task_data_get_async_pool (void);
static void gee_async_task_data_free (gpointer _data);
static gboolean gee_async_task_co (GeeAsyncTaskData* _data_);
static gpointer _gee_async_task_co_gee_task (gpointer self);
static void gee_task_data_instance_init (GeeTaskData * self);
 G_GNUC_INTERNAL void gee_task_data_run (GeeTaskData* self);
static GThreadPool* __lambda58_ (void);
static void ___lambda59_ (GeeTaskData* tdata);
static void ____lambda59__gfunc (gpointer data,
                          gpointer self);
static gpointer ___lambda58__gthread_func (gpointer self);

/**
 * Schedules a task to execute asynchroniously. Internally one
 * of threads from pool will execute the task.
 *
 * Note: There is limited number of threads unless environment variable
 *   ``GEE_NUM_THREADS`` is set to -1. It is not advised to call I/O or
 *   block inside the taks. If necessary it is possible to create a new one
 *   by anyther call.
 *
 * @param task Task to be executed
 * @return Future value returned by task
 * @see async_task
 * @since 0.11.0
 */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "task.vala"
	return self ? g_object_ref (self) : NULL;
#line 104 "task.c"
}

GeeFuture*
gee_task (GType g_type,
          GBoxedCopyFunc g_dup_func,
          GDestroyNotify g_destroy_func,
          GeeTask task,
          gpointer task_target,
          GError** error)
{
	GeeTaskData* tdata = NULL;
	GeeTaskData* _tmp0_;
	GeeTaskData* _tmp1_;
	GeeTask _tmp2_;
	gpointer _tmp2__target;
	GeeTaskData* _tmp3_;
	GeePromise* _tmp4_;
	GeeFuture* _result_ = NULL;
	GeeTaskData* _tmp5_;
	GeePromise* _tmp6_;
	GeeFuture* _tmp7_;
	GeeFuture* _tmp8_;
	GeeFuture* _tmp9_;
	GThreadPool* _tmp10_;
	GeeTaskData* _tmp11_;
	GError* _inner_error0_ = NULL;
	GeeFuture* result;
#line 41 "task.vala"
	_tmp0_ = gee_task_data_new ();
#line 41 "task.vala"
	tdata = _tmp0_;
#line 42 "task.vala"
	_tmp1_ = tdata;
#line 42 "task.vala"
	_tmp2_ = task;
#line 42 "task.vala"
	_tmp2__target = task_target;
#line 42 "task.vala"
	task = NULL;
#line 42 "task.vala"
	task_target = NULL;
#line 42 "task.vala"
	_tmp1_->function = _tmp2_;
#line 42 "task.vala"
	_tmp1_->function_target = _tmp2__target;
#line 43 "task.vala"
	_tmp3_ = tdata;
#line 43 "task.vala"
	_tmp4_ = gee_promise_new (g_type, (GBoxedCopyFunc) g_dup_func, (GDestroyNotify) g_destroy_func);
#line 43 "task.vala"
	_gee_promise_unref0 (_tmp3_->promise);
#line 43 "task.vala"
	_tmp3_->promise = _tmp4_;
#line 44 "task.vala"
	_tmp5_ = tdata;
#line 44 "task.vala"
	_tmp6_ = _tmp5_->promise;
#line 44 "task.vala"
	_tmp7_ = gee_promise_get_future (_tmp6_);
#line 44 "task.vala"
	_tmp8_ = _tmp7_;
#line 44 "task.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 44 "task.vala"
	_result_ = _tmp9_;
#line 45 "task.vala"
	_tmp10_ = gee_task_data_get_async_pool ();
#line 45 "task.vala"
	_tmp11_ = tdata;
#line 45 "task.vala"
	tdata = NULL;
#line 45 "task.vala"
	g_thread_pool_push (_tmp10_, _tmp11_, &_inner_error0_);
#line 45 "task.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 45 "task.vala"
		if (_inner_error0_->domain == G_THREAD_ERROR) {
#line 45 "task.vala"
			g_propagate_error (error, _inner_error0_);
#line 45 "task.vala"
			_g_object_unref0 (_result_);
#line 45 "task.vala"
			_gee_task_data_free0 (tdata);
#line 45 "task.vala"
			return NULL;
#line 190 "task.c"
		} else {
#line 45 "task.vala"
			_g_object_unref0 (_result_);
#line 45 "task.vala"
			_gee_task_data_free0 (tdata);
#line 45 "task.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 45 "task.vala"
			g_clear_error (&_inner_error0_);
#line 45 "task.vala"
			return NULL;
#line 202 "task.c"
		}
	}
#line 46 "task.vala"
	result = _result_;
#line 46 "task.vala"
	_gee_task_data_free0 (tdata);
#line 46 "task.vala"
	return result;
#line 211 "task.c"
}

static void
gee_async_task_data_free (gpointer _data)
{
	GeeAsyncTaskData* _data_;
	_data_ = _data;
	g_slice_free (GeeAsyncTaskData, _data_);
}

void
gee_async_task (GAsyncReadyCallback _callback_,
                gpointer _user_data_)
{
	GeeAsyncTaskData* _data_;
	_data_ = g_slice_new0 (GeeAsyncTaskData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, gee_async_task_data_free);
	gee_async_task_co (_data_);
}

void
gee_async_task_finish (GAsyncResult* _res_,
                       GError** error)
{
	GeeAsyncTaskData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

/**
 * Continues the execution asynchroniously in helper thread. Internally
 * one of threads from pool will execute the task.
 *
 * Note: There is limited number of threads unless environment variable
 *   ``GEE_NUM_THREADS`` is set to -1. It is not advised to call I/O or
 *   block inside the taks. If necessary it is possible to create a new one
 *   by anyther call.
 *
 * @see task
 * @since 0.11.0
 */
static gpointer
_gee_async_task_co_gee_task (gpointer self)
{
	gpointer result;
	result = (gpointer) ((gintptr) gee_async_task_co (self));
#line 62 "task.vala"
	return result;
#line 263 "task.c"
}

static gboolean
gee_async_task_co (GeeAsyncTaskData* _data_)
{
#line 61 "task.vala"
	switch (_data_->_state_) {
#line 61 "task.vala"
		case 0:
#line 273 "task.c"
		goto _state_0;
		default:
#line 61 "task.vala"
		g_assert_not_reached ();
#line 278 "task.c"
	}
	_state_0:
#line 62 "task.vala"
	_data_->_tmp0_ = gee_task (G_TYPE_BOOLEAN, NULL, NULL, _gee_async_task_co_gee_task, _data_, &_data_->_inner_error0_);
#line 62 "task.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 62 "task.vala"
	_g_object_unref0 (_data_->_tmp1_);
#line 62 "task.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 62 "task.vala"
		if (_data_->_inner_error0_->domain == G_THREAD_ERROR) {
#line 62 "task.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 62 "task.vala"
			g_object_unref (_data_->_async_result);
#line 62 "task.vala"
			return FALSE;
#line 297 "task.c"
		} else {
#line 62 "task.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 62 "task.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 62 "task.vala"
			g_object_unref (_data_->_async_result);
#line 62 "task.vala"
			return FALSE;
#line 307 "task.c"
		}
	}
#line 61 "task.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 61 "task.vala"
	if (_data_->_state_ != 0) {
#line 61 "task.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 61 "task.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 318 "task.c"
		}
	}
#line 61 "task.vala"
	g_object_unref (_data_->_async_result);
#line 61 "task.vala"
	return FALSE;
#line 325 "task.c"
}

 G_GNUC_INTERNAL void
gee_task_data_run (GeeTaskData* self)
{
	GeePromise* _tmp0_;
	GeeTask _tmp1_;
	gpointer _tmp1__target;
	gpointer _tmp2_;
#line 69 "task.vala"
	g_return_if_fail (self != NULL);
#line 70 "task.vala"
	_tmp0_ = self->promise;
#line 70 "task.vala"
	_tmp1_ = self->function;
#line 70 "task.vala"
	_tmp1__target = self->function_target;
#line 70 "task.vala"
	_tmp2_ = _tmp1_ (_tmp1__target);
#line 70 "task.vala"
	gee_promise_set_value (_tmp0_, _tmp2_);
#line 347 "task.c"
}

static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar** unparsed,
                 guint _base)
{
	gint64 _vala__result_ = 0LL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 783 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 785 "glib-2.0.vapi"
	errno = 0;
#line 786 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, _base);
#line 786 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 786 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 787 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 787 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 787 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 787 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 383 "task.c"
		gboolean _tmp5_ = FALSE;
#line 788 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 789 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 789 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 391 "task.c"
		} else {
#line 789 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 395 "task.c"
		}
#line 789 "glib-2.0.vapi"
		result = _tmp5_;
#line 789 "glib-2.0.vapi"
		if (_result_) {
#line 789 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 403 "task.c"
		}
#line 789 "glib-2.0.vapi"
		if (unparsed) {
#line 789 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 409 "task.c"
		}
#line 789 "glib-2.0.vapi"
		return result;
#line 413 "task.c"
	} else {
		gchar* _tmp6_;
#line 791 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 791 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 792 "glib-2.0.vapi"
		result = FALSE;
#line 792 "glib-2.0.vapi"
		if (_result_) {
#line 792 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 426 "task.c"
		}
#line 792 "glib-2.0.vapi"
		if (unparsed) {
#line 792 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 432 "task.c"
		}
#line 792 "glib-2.0.vapi"
		return result;
#line 436 "task.c"
	}
}

static void
___lambda59_ (GeeTaskData* tdata)
{
#line 84 "task.vala"
	g_return_if_fail (tdata != NULL);
#line 85 "task.vala"
	gee_task_data_run (tdata);
#line 84 "task.vala"
	_gee_task_data_free0 (tdata);
#line 449 "task.c"
}

static void
____lambda59__gfunc (gpointer data,
                     gpointer self)
{
#line 84 "task.vala"
	___lambda59_ ((GeeTaskData*) data);
#line 458 "task.c"
}

static GThreadPool*
__lambda58_ (void)
{
	gint num_threads = 0;
	gchar* gee_num_threads_str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	GThreadPool* result;
#line 75 "task.vala"
	num_threads = (gint) g_get_num_processors ();
#line 76 "task.vala"
	_tmp0_ = g_getenv ("GEE_NUM_THREADS");
#line 76 "task.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 76 "task.vala"
	gee_num_threads_str = _tmp1_;
#line 77 "task.vala"
	_tmp2_ = gee_num_threads_str;
#line 77 "task.vala"
	if (_tmp2_ != NULL) {
#line 483 "task.c"
		gint64 _result_ = 0LL;
		const gchar* _tmp3_;
		gint64 _tmp4_ = 0LL;
		gboolean _tmp5_;
#line 79 "task.vala"
		_tmp3_ = gee_num_threads_str;
#line 79 "task.vala"
		_tmp5_ = int64_try_parse (_tmp3_, &_tmp4_, NULL, (guint) 0);
#line 79 "task.vala"
		_result_ = _tmp4_;
#line 79 "task.vala"
		if (_tmp5_) {
#line 80 "task.vala"
			num_threads = (gint) _result_;
#line 498 "task.c"
		}
	}
	{
		GThreadPool* _tmp6_ = NULL;
		GThreadPool* _tmp7_;
		GThreadPool* _tmp8_;
#line 84 "task.vala"
		_tmp7_ = g_thread_pool_new (____lambda59__gfunc, NULL, num_threads, FALSE, &_inner_error0_);
#line 84 "task.vala"
		_tmp6_ = _tmp7_;
#line 84 "task.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "task.vala"
			if (_inner_error0_->domain == G_THREAD_ERROR) {
#line 513 "task.c"
				goto __catch0_g_thread_error;
			}
#line 84 "task.vala"
			_g_free0 (gee_num_threads_str);
#line 84 "task.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "task.vala"
			g_clear_error (&_inner_error0_);
#line 84 "task.vala"
			return NULL;
#line 524 "task.c"
		}
#line 84 "task.vala"
		_tmp8_ = _tmp6_;
#line 84 "task.vala"
		_tmp6_ = NULL;
#line 84 "task.vala"
		result = _tmp8_;
#line 84 "task.vala"
		_g_thread_pool_free0 (_tmp6_);
#line 84 "task.vala"
		_g_free0 (gee_num_threads_str);
#line 84 "task.vala"
		return result;
#line 538 "task.c"
	}
	goto __finally0;
	__catch0_g_thread_error:
	{
#line 83 "task.vala"
		g_clear_error (&_inner_error0_);
#line 88 "task.vala"
		abort ();
#line 547 "task.c"
	}
	__finally0:
#line 83 "task.vala"
	_g_free0 (gee_num_threads_str);
#line 83 "task.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "task.vala"
	g_clear_error (&_inner_error0_);
#line 83 "task.vala"
	return NULL;
#line 558 "task.c"
}

static gpointer
___lambda58__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda58_ ();
#line 74 "task.vala"
	return result;
#line 568 "task.c"
}

 G_GNUC_INTERNAL GThreadPool*
gee_task_data_get_async_pool (void)
{
	gconstpointer _tmp0_;
	GThreadPool* result;
#line 74 "task.vala"
	_tmp0_ = g_once (&gee_task_data_async_pool, ___lambda58__gthread_func, NULL);
#line 74 "task.vala"
	result = (GThreadPool*) _tmp0_;
#line 74 "task.vala"
	return result;
#line 582 "task.c"
}

 G_GNUC_INTERNAL GeeTaskData*
gee_task_data_new (void)
{
	GeeTaskData* self;
#line 66 "task.vala"
	self = g_slice_new0 (GeeTaskData);
#line 66 "task.vala"
	gee_task_data_instance_init (self);
#line 66 "task.vala"
	return self;
#line 595 "task.c"
}

static void
gee_task_data_instance_init (GeeTaskData * self)
{
}

 G_GNUC_INTERNAL void
gee_task_data_free (GeeTaskData * self)
{
#line 68 "task.vala"
	_gee_promise_unref0 (self->promise);
#line 66 "task.vala"
	g_slice_free (GeeTaskData, self);
#line 610 "task.c"
}

